| Flutter Impeller |

Public Member Functions | Public Attributes | List of all members
impeller::TextureDescriptor Struct Reference

A lightweight object that describes the attributes of a texture that can then used an allocator to create that texture. More...

`#include <texture_descriptor.h>`

## Public Member Functions
constexpr size_t | GetByteSizeOfBaseMipLevel () const
constexpr size_t | GetBytesPerRow () const
constexpr bool | SamplingOptionsAreValid () const
constexpr bool | operator== (const TextureDescriptor &other) const
constexpr bool | operator!= (const TextureDescriptor &other) const
constexpr bool | IsValid () const

## Public Attributes
StorageMode | storage_mode = StorageMode::kDeviceTransient
TextureType | type = TextureType::kTexture2D
PixelFormat | format = PixelFormat::kUnknown
ISize | size
size_t | mip_count = 1u
TextureUsageMask | usage = TextureUsage::kShaderRead
SampleCount | sample_count = SampleCount::kCount1
CompressionType | compression_type = CompressionType::kLossless

## Detailed Description

A lightweight object that describes the attributes of a texture that can then used an allocator to create that texture.

Definition at line 37 of file texture_descriptor.h.

## Member Function Documentation

## ◆ GetByteSizeOfBaseMipLevel()

constexpr size_t impeller::TextureDescriptor::GetByteSizeOfBaseMipLevel | ( |  | ) | const
| inline constexpr

Definition at line 47 of file texture_descriptor.h.

47 {
48 if (!IsValid()) {
49 return 0u;
50 }
51 return size.Area() * BytesPerPixelForPixelFormat(format);
52 }

References impeller::TSize< T >::Area(), impeller::BytesPerPixelForPixelFormat(), format, IsValid(), and size.

Referenced by impeller::UploadGlyphTextureAtlas().

## ◆ GetBytesPerRow()

constexpr size_t impeller::TextureDescriptor::GetBytesPerRow | ( |  | ) | const
| inline constexpr

Definition at line 54 of file texture_descriptor.h.

54 {
55 if (!IsValid()) {
56 return 0u;
57 }
58 return size.width * BytesPerPixelForPixelFormat(format);
59 }

References impeller::BytesPerPixelForPixelFormat(), format, IsValid(), size, and impeller::TSize< T >::width.

## ◆ IsValid()

constexpr bool impeller::TextureDescriptor::IsValid | ( |  | ) | const
| inline constexpr

Definition at line 81 of file texture_descriptor.h.

81 {
82 return format != PixelFormat::kUnknown && //
83 !size.IsEmpty() && //
84 mip_count >= 1u && //
85 SamplingOptionsAreValid();
86 }

References format, impeller::TSize< T >::IsEmpty(), impeller::kUnknown, mip_count, SamplingOptionsAreValid(), and size.

Referenced by GetByteSizeOfBaseMipLevel(), GetBytesPerRow(), impeller::TextureMTL::TextureMTL(), and impeller::ToMTLTextureDescriptor().

## ◆ operator!=()

constexpr bool impeller::TextureDescriptor::operator!= | ( | const TextureDescriptor & | other | ) | const
| inline constexpr

Definition at line 77 of file texture_descriptor.h.

77 {
78 return !(*this == other);
79 }

## ◆ operator==()

constexpr bool impeller::TextureDescriptor::operator== | ( | const TextureDescriptor & | other | ) | const
| inline constexpr

Definition at line 66 of file texture_descriptor.h.

66 {
67 return size == other.size && //
68 storage_mode == other.storage_mode && //
69 format == other.format && //
70 usage == other.usage && //
71 sample_count == other.sample_count && //
72 type == other.type && //
73 compression_type == other.compression_type && //
74 mip_count == other.mip_count;
75 }

References compression_type, format, mip_count, sample_count, size, storage_mode, type, and usage.

## ◆ SamplingOptionsAreValid()

constexpr bool impeller::TextureDescriptor::SamplingOptionsAreValid | ( |  | ) | const
| inline constexpr

Definition at line 61 of file texture_descriptor.h.

61 {
62 const auto count = static_cast<uint64_t>(sample_count);
63 return IsMultisampleCapable(type) ? count > 1 : count == 1;
64 }

References impeller::IsMultisampleCapable(), sample_count, and type.

Referenced by IsValid().

## Member Data Documentation

## ◆ compression_type

CompressionType impeller::TextureDescriptor::compression_type = CompressionType::kLossless

Definition at line 45 of file texture_descriptor.h.

Referenced by impeller::RenderTargetAllocator::CreateOffscreenMSAA(), operator==(), impeller::testing::TEST(), impeller::TextureDescriptorToString(), impeller::ToTextureDescriptor(), and impeller::WrapTextureWithRenderTarget().

## ◆ format

PixelFormat impeller::TextureDescriptor::format = PixelFormat::kUnknown

Definition at line 40 of file texture_descriptor.h.

Referenced by impeller::AllocatedTextureSourceVK::AllocatedTextureSourceVK(), impeller::CreateGradientTexture(), impeller::RenderTargetAllocator::CreateOffscreen(), impeller::RenderTargetAllocator::CreateOffscreenMSAA(), impeller::testing::CreateTestYUVTextures(), GetByteSizeOfBaseMipLevel(), GetBytesPerRow(), impeller::scene::Skin::GetJointsTexture(), impeller::KHRSwapchainImageVK::GetPixelFormat(), impeller::GetTextureTypeFromDescriptor(), IsValid(), impeller::KHRSwapchainImageVK::KHRSwapchainImageVK(), operator==(), impeller::scene::SceneContext::SceneContext(), impeller::TextureSourceVK::SetLayout(), impeller::RenderTarget::SetupDepthStencilAttachments(), impeller::testing::TEST(), impeller::testing::TEST_P(), impeller::TextureDescriptorToString(), impeller::ToMTLTextureDescriptor(), impeller::ToTextureDescriptor(), impeller::UploadGlyphTextureAtlas(), impeller::SurfaceGLES::WrapFBO(), impeller::KHRSurfaceVK::WrapSwapchainImage(), impeller::WrapTextureMTL(), and impeller::WrapTextureWithRenderTarget().

## ◆ mip_count

size_t impeller::TextureDescriptor::mip_count = 1u

Definition at line 42 of file texture_descriptor.h.

Referenced by impeller::AllocatedTextureSourceVK::AllocatedTextureSourceVK(), impeller::SamplerGLES::ConfigureBoundTexture(), impeller::RenderTargetAllocator::CreateOffscreen(), impeller::RenderTargetAllocator::CreateOffscreenMSAA(), impeller::Allocator::CreateTexture(), impeller::scene::Skin::GetJointsTexture(), impeller::Texture::GetMipCount(), IsValid(), impeller::KHRSwapchainImageVK::KHRSwapchainImageVK(), impeller::Texture::NeedsMipmapGeneration(), operator==(), impeller::scene::SceneContext::SceneContext(), impeller::TextureSourceVK::SetLayout(), impeller::testing::TEST(), impeller::testing::TEST_P(), impeller::TextureDescriptorToString(), impeller::ToMTLTextureDescriptor(), and impeller::ToTextureDescriptor().

## ◆ sample_count

SampleCount impeller::TextureDescriptor::sample_count = SampleCount::kCount1

Definition at line 44 of file texture_descriptor.h.

Referenced by impeller::AllocatedTextureSourceVK::AllocatedTextureSourceVK(), impeller::RenderTargetAllocator::CreateOffscreenMSAA(), impeller::GetTextureTypeFromDescriptor(), operator==(), SamplingOptionsAreValid(), impeller::RenderTarget::SetupDepthStencilAttachments(), impeller::testing::TEST(), impeller::testing::TEST_P(), impeller::TextureDescriptorToString(), impeller::ToMTLTextureDescriptor(), impeller::ToTextureDescriptor(), impeller::SurfaceGLES::WrapFBO(), impeller::KHRSurfaceVK::WrapSwapchainImage(), and impeller::WrapTextureWithRenderTarget().

## ◆ size

ISize impeller::TextureDescriptor::size

Definition at line 41 of file texture_descriptor.h.

Referenced by impeller::AllocatedTextureSourceVK::AllocatedTextureSourceVK(), impeller::CreateGradientTexture(), impeller::RenderTargetAllocator::CreateOffscreen(), impeller::RenderTargetAllocator::CreateOffscreenMSAA(), impeller::testing::CreateTestYUVTextures(), impeller::Allocator::CreateTexture(), GetByteSizeOfBaseMipLevel(), GetBytesPerRow(), impeller::scene::Skin::GetJointsTexture(), impeller::KHRSwapchainImageVK::GetSize(), impeller::TextureVK::GetSize(), IsValid(), operator==(), impeller::scene::SceneContext::SceneContext(), impeller::RenderTarget::SetupDepthStencilAttachments(), impeller::testing::TEST(), impeller::testing::TEST_P(), impeller::TextureDescriptorToString(), impeller::TextureMTL::TextureMTL(), impeller::ToMTLTextureDescriptor(), impeller::ToTextureDescriptor(), impeller::UploadGlyphTextureAtlas(), impeller::SurfaceGLES::WrapFBO(), impeller::KHRSurfaceVK::WrapSwapchainImage(), and impeller::WrapTextureWithRenderTarget().

## ◆ storage_mode

StorageMode impeller::TextureDescriptor::storage_mode = StorageMode::kDeviceTransient

Definition at line 38 of file texture_descriptor.h.

Referenced by impeller::AllocatedTextureSourceVK::AllocatedTextureSourceVK(), impeller::CreateGradientTexture(), impeller::RenderTargetAllocator::CreateOffscreen(), impeller::RenderTargetAllocator::CreateOffscreenMSAA(), impeller::testing::CreateTestYUVTextures(), impeller::Playground::CreateTextureCubeForFixture(), impeller::CreateTextureForDecompressedImage(), impeller::scene::Skin::GetJointsTexture(), ImGui_ImplImpeller_Init(), operator==(), impeller::scene::SceneContext::SceneContext(), impeller::RenderTarget::SetupDepthStencilAttachments(), impeller::testing::TEST(), impeller::testing::TEST_P(), impeller::TextureDescriptorToString(), impeller::ToTextureDescriptor(), impeller::scene::UnpackTextureFromFlatbuffer(), impeller::UploadGlyphTextureAtlas(), impeller::SurfaceGLES::WrapFBO(), impeller::KHRSurfaceVK::WrapSwapchainImage(), and impeller::WrapTextureWithRenderTarget().

## ◆ type

TextureType impeller::TextureDescriptor::type = TextureType::kTexture2D

Definition at line 39 of file texture_descriptor.h.

Referenced by impeller::AllocatedTextureSourceVK::AllocatedTextureSourceVK(), impeller::SamplerGLES::ConfigureBoundTexture(), impeller::RenderTargetAllocator::CreateOffscreenMSAA(), impeller::TextureGLES::GenerateMipmap(), impeller::KHRSwapchainImageVK::KHRSwapchainImageVK(), operator==(), SamplingOptionsAreValid(), impeller::TextureSourceVK::SetLayout(), impeller::RenderTarget::SetupDepthStencilAttachments(), impeller::testing::TEST(), impeller::testing::TEST_P(), impeller::TextureDescriptorToString(), impeller::ToMTLTextureDescriptor(), impeller::ToTextureDescriptor(), impeller::SurfaceGLES::WrapFBO(), impeller::KHRSurfaceVK::WrapSwapchainImage(), and impeller::WrapTextureWithRenderTarget().

## ◆ usage

TextureUsageMask impeller::TextureDescriptor::usage = TextureUsage::kShaderRead

Definition at line 43 of file texture_descriptor.h.

Referenced by impeller::AllocatedTextureSourceVK::AllocatedTextureSourceVK(), impeller::RenderTargetAllocator::CreateOffscreen(), impeller::RenderTargetAllocator::CreateOffscreenMSAA(), impeller::GetTextureTypeFromDescriptor(), operator==(), impeller::RenderTarget::SetupDepthStencilAttachments(), impeller::testing::TEST_P(), impeller::ToMTLTextureDescriptor(), impeller::SurfaceGLES::WrapFBO(), impeller::KHRSurfaceVK::WrapSwapchainImage(), and impeller::WrapTextureWithRenderTarget().

The documentation for this struct was generated from the following file:

- impeller/core/texture_descriptor.h

impeller::TextureDescriptor::format
PixelFormat format
Definition: texture_descriptor.h:40
impeller::TextureDescriptor::mip_count
size_t mip_count
Definition: texture_descriptor.h:42
impeller::TextureDescriptor::sample_count
SampleCount sample_count
Definition: texture_descriptor.h:44
impeller::TextureDescriptor::usage
TextureUsageMask usage
Definition: texture_descriptor.h:43
impeller::TextureDescriptor::type
TextureType type
Definition: texture_descriptor.h:39
impeller::TextureDescriptor::IsValid
constexpr bool IsValid() const
Definition: texture_descriptor.h:81
impeller::BytesPerPixelForPixelFormat
constexpr size_t BytesPerPixelForPixelFormat(PixelFormat format)
Definition: formats.h:448
impeller::IsMultisampleCapable
constexpr bool IsMultisampleCapable(TextureType type)
Definition: formats.h:284
impeller::TSize::width
Type width
Definition: size.h:22
impeller::PixelFormat::kUnknown
@ kUnknown
impeller::TextureDescriptor::size
ISize size
Definition: texture_descriptor.h:41
impeller::TSize::Area
constexpr Type Area() const
Definition: size.h:102
impeller::TextureDescriptor::SamplingOptionsAreValid
constexpr bool SamplingOptionsAreValid() const
Definition: texture_descriptor.h:61
impeller::TextureDescriptor::storage_mode
StorageMode storage_mode
Definition: texture_descriptor.h:38
impeller::TSize::IsEmpty
constexpr bool IsEmpty() const
Returns true if either of the width or height are 0, negative, or NaN.
Definition: size.h:105
impeller::TextureDescriptor::compression_type
CompressionType compression_type
Definition: texture_descriptor.h:45